# Neural network for MFR correction MFR=f(MFR_obs,DD)

#import pandas as pd
import xlrd
import numpy as np
import matplotlib.pyplot as plt
from keras.layers import Dense
from keras.models import Sequential, load_model
from keras import optimizers, callbacks

# seed - to repeat results
seed = 0
np.random.seed(seed)

#%% Load the full dataset (for testing)
full = xlrd.open_workbook('./dataset1_full.xlsx').sheet_by_index(0)

# Column numbers
MFR_obs = 5 
DD = 7      
MFR_err = 8  

# Row numbers
start = 4 
end = 106 

Test_X = np.zeros((end - start + 1, 2))  # Input data for NN
Test_Y = np.zeros((end - start + 1, 1))  # Output 

i = 0
for row in range(start, end + 1):
    Test_X[int(i)][0] = full.cell(row, MFR_obs).value   # MFR_obs
    Test_X[int(i)][1] = full.cell(row, DD).value        # DD
    Test_Y[int(i)][0] = full.cell(row, MFR_err).value   # MFR_err
    i = i + 1

##%% Load the dataset2.xlsx
#second = xlrd.open_workbook('./dataset2.xlsx').sheet_by_index(0)
#
## Row numbers
#start = 4 
#end = 56
#
#X = np.zeros((end - start + 1, 2))  # Input data for NN
#Y = np.zeros((end - start + 1, 1))  # Output 
#
#i = 0
#for row in range(start, end + 1):
#    X[int(i)][0] = second.cell(row, MFR_obs).value   # MFR_obs
#    X[int(i)][1] = second.cell(row, DD).value        # DD
#    Y[int(i)][0] = second.cell(row, MFR_err).value   # MFR_err
#    i = i + 1    

#%% Load the dataset3.xlsx
third = xlrd.open_workbook('./dataset3.xlsx').sheet_by_index(0)

# Row numbers
start = 4 
end = 55

X = np.zeros((end - start + 1, 2))  # Input data for NN
Y = np.zeros((end - start + 1, 1))  # Output 

i = 0
for row in range(start, end + 1):
    X[int(i)][0] = third.cell(row, MFR_obs).value   # MFR_obs
    X[int(i)][1] = third.cell(row, DD).value        # DD
    Y[int(i)][0] = third.cell(row, MFR_err).value   # MFR_err
    i = i + 1    

#%%
# Choose an activation function ('softplus', 'relu', 'selu', 'tanh')
af = 'tanh'

# Choose the number of neurons on the hidden layer
neurons_number = 6

# Select the optimizer 
#optimizer = optimizers.Adam(lr=0.001, beta_1=0.9, beta_2=0.999, epsilon=None, decay=0.0, amsgrad=False)
optimizer='adam'
#optimizer=optimizers.SGD(lr=0.001, decay=1e-6, momentum=0.99, nesterov=True)
#optimizer='sgd'
#%% Build a model and train it
model = Sequential()
model.add(Dense(neurons_number, activation = af, input_shape=(X.shape[1],)))
model.add(Dense(1))

model.compile(loss='mse', optimizer=optimizer, metrics=['mae'])

es = callbacks.EarlyStopping(monitor='val_mean_absolute_error', mode='auto', 
                             verbose=1, patience=500)
mc = callbacks.ModelCheckpoint('best_model.h5', monitor='val_mean_absolute_error', 
                               mode='auto', verbose=1, save_best_only=True)
  
history = model.fit(X, Y, epochs=4000, callbacks=[es,mc], validation_split=0.1, batch_size=1, verbose=1)
saved_model = load_model('best_model.h5') 
 
# Plot MAE for training and validation sets 
mean_abs_error = history.history['mean_absolute_error']
val_mean_abs_error = history.history['val_mean_absolute_error']
  
epochs = range(len(mean_abs_error))

plt.plot(epochs, mean_abs_error, 'r', label='Mean absolute error')
plt.plot(epochs, val_mean_abs_error, 'b', label='Validation mean absolute error')
plt.title('Training and validation mean absolute error')
plt.xlabel('Epochs')
plt.ylabel('Error')
plt.legend()

plt.show()
#%% Find MAE on the full dataset for the best model      
test_loss, test_acc = saved_model.evaluate(Test_X, Test_Y)
print(test_acc)

#print(saved_model.evaluate(X, Y))
